#include <iostream>
#include <vector>
#include <cstdlib>
using namespace std;
struct Input
{
    vector<double> numbers;
    size_t bin_count{};
};

Input
input_data()
{
    Input in;
    size_t number_count;
    cerr << "Enter number count: ";
    cin >> number_count;

    in.numbers.resize(number_count);
    vector<double> numbers(number_count);

    for (size_t i = 0; i < number_count; i++)
    {
        cerr << "Enter numbers: ";
        cin >> in.numbers[i];
    }
    size_t bin_count;
    cerr << "Enter bin count: ";
    cin >> in.bin_count;
    return in;
}

void
find_minmax(const vector<double>& numbers, double& min, double& max)
{
    min = numbers[0];
    for (size_t i = 1; i < numbers.size(); i++)
    {
        if (numbers[i] < min)
        {
            min = numbers[i];
        }
        else if (numbers[i] > max)
        {
            max = numbers[i];
        }
    }
}

vector<size_t> make_histogram(const vector<double>& numbers,size_t bin_count) {
    vector<size_t> bins(bin_count, 0);
    double min, max;
    find_minmax(numbers, min, max);

    double bin_size = (max - min) / bin_count;
    if (bin_size == 0) bin_size = 1;

    for (double num : numbers) {
        bool found = false;
        for (size_t i = 0; i < bin_count - 1; ++i) {
            double lo = min + i * bin_size;
            double hi = lo + bin_size;
            if (lo <= num && num < hi) {
                bins[i]++;
                found = true;
                break;
            }
        }
        if (!found) bins.back()++;
    }
    return bins;
}
void show_histogram_text(const vector<size_t>& bins, size_t& bin_count, double bin_size)
{
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;
    size_t max_bin_count = bins[0];
    for(size_t i = 0; i < bin_count; i++)
    {
        if(bins[i] > max_bin_count)
        {
            max_bin_count = bins[i];
        }
    }

    for(size_t i = 0; i < bin_count; i++)
    {
        if(bins[i]<10)
        {
            cout<< "  " << bins[i] << "|";
        }
        else
        {
            if(bins[i]<100)
            {
                cout<< " " << bins[i] << "|";
            }
            else
            {
                if(bins[i]<1000)
                {
                    cout<< bins[i] << "|";
                }

            }
        }

        size_t height;
        if(max_bin_count <= MAX_ASTERISK)
        {
            height = bins[i];
        }
        else
        {
            height = MAX_ASTERISK * (static_cast<double>(bins[i]) / max_bin_count);
        }
        for(size_t j = 0; j < height;  j ++)
        {
            cout<<"*";
        }
        cout<<endl;
    }
}

int main()
{
    auto in = input_data();
   auto bins = make_histogram(in.numbers, in.bin_count);

   double min, max;
   double bin_size = (max - min) / in.bin_count;
    show_histogram_text(bins, in.bin_count, bin_size);

    //#  +  ()

}
//  | 3 3 5 5 5 4 4 4 4 4
